export enum SocketDisconnectCode {
  CLOSE_NORMAL = 1000,
  CLOSE_GOING_AWAY = 1001,
  CLOSE_PROTOCOL_ERROR = 1002,
  CLOSE_UNSUPPORTED = 1003,
  CLOSE_NO_STATUS = 1005,
  CLOSE_ABNORMAL = 1006,
  CLOSE_TOO_LARGE = 1009,
  CLOSE_EXTENSION_REQUIRED = 1010,
  CLOSE_INTERNAL_ERROR = 1011,
  CLOSE_SERVICE_RESTART = 1012,
  CLOSE_TRY_AGAIN_LATER = 1013,
  CLOSE_TLS_HANDSHAKE = 1015,
}

export const NON_RECONNECT_CODES = [
  SocketDisconnectCode.CLOSE_NORMAL,
  SocketDisconnectCode.CLOSE_GOING_AWAY,
  SocketDisconnectCode.CLOSE_UNSUPPORTED,
  SocketDisconnectCode.CLOSE_TOO_LARGE,
  SocketDisconnectCode.CLOSE_EXTENSION_REQUIRED,
  SocketDisconnectCode.CLOSE_TRY_AGAIN_LATER,
  SocketDisconnectCode.CLOSE_TLS_HANDSHAKE,
] as const;

export enum ManagedSocketErrorType {
  INVALID_MESSAGE_SHAPE = "Invalid message shape.",
  CATASTROPHIC_CLOSE = "Catastrophic close code",
  SOCKET_ERROR = "WebSocket error",
  CONNECTION_REJECTED = "Connection rejected",
}
