import { ManagedSocketErrorType } from "./constants";

export class ManagedSocketError extends Error {
  public originalError: Error | ErrorEvent;
  public type: ManagedSocketErrorType = ManagedSocketErrorType.SOCKET_ERROR;

  constructor(
    message: string,
    originalError: Error | ErrorEvent,
    type?: ManagedSocketErrorType,
  ) {
    super(message);
    this.name = "ManagedSocketError";
    this.originalError = originalError;
    this.type = type ?? this.type;
  }
}
